'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createReducer = exports.injectReducer = exports.makeAllReducer = undefined;

var _redux = require('redux');

var makeAllReducer = exports.makeAllReducer = function makeAllReducer(asyncReducers) {
  return (0, _redux.combineReducers)({
    ...asyncReducers
  });
}; /*
    * @Author: Conroy 
    * @Date: 2018-07-11 14:55:13 
    * @Last Modified by: Conroy
    * @Last Modified time: 2018-07-13 10:43:29
    */

var injectReducer = exports.injectReducer = function injectReducer(store, _ref) {
  var key = _ref.key,
      reducer = _ref.reducer;

  if (Object.hasOwnProperty.call(store.asyncReducers, key)) return;
  store.asyncReducers[key] = reducer;
  // console.log(makeAllReducer(store.asyncReducers))
  store.replaceReducer(makeAllReducer(store.asyncReducers));
};

var createReducer = exports.createReducer = function createReducer(initialState, ACTION_HANDLES) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    var handler = ACTION_HANDLES[action.type];
    return handler ? handler(state, action) : state;
  };
};